Merge branch 'js/iso8895-test-on-apfs'
[alt-git.git] / git-submodule.sh
blob99fba417b1e742e70f6ff8ccb31b58ee181bc4f7
1 #!/bin/sh
3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] [--cached]
9 or: $dashless [--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
10 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
11 or: $dashless [--quiet] init [--] [<path>...]
12 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
13 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
14 or: $dashless [--quiet] set-branch (--default|--branch <branch>) [--] <path>
15 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
16 or: $dashless [--quiet] foreach [--recursive] <command>
17 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
18 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
19 OPTIONS_SPEC=
20 SUBDIRECTORY_OK=Yes
21 . git-sh-setup
22 . git-parse-remote
23 require_work_tree
24 wt_prefix=$(git rev-parse --show-prefix)
25 cd_to_toplevel
27 # Tell the rest of git that any URLs we get don't come
28 # directly from the user, so it can apply policy as appropriate.
29 GIT_PROTOCOL_FROM_USER=0
30 export GIT_PROTOCOL_FROM_USER
32 command=
33 branch=
34 force=
35 reference=
36 cached=
37 recursive=
38 init=
39 files=
40 remote=
41 nofetch=
42 update=
43 prefix=
44 custom_name=
45 depth=
46 progress=
47 dissociate=
49 die_if_unmatched ()
51 if test "$1" = "#unmatched"
52 then
53 exit ${2:-1}
58 # Print a submodule configuration setting
60 # $1 = submodule name
61 # $2 = option name
62 # $3 = default value
64 # Checks in the usual git-config places first (for overrides),
65 # otherwise it falls back on .gitmodules. This allows you to
66 # distribute project-wide defaults in .gitmodules, while still
67 # customizing individual repositories if necessary. If the option is
68 # not in .gitmodules either, print a default value.
70 get_submodule_config () {
71 name="$1"
72 option="$2"
73 default="$3"
74 value=$(git config submodule."$name"."$option")
75 if test -z "$value"
76 then
77 value=$(git submodule--helper config submodule."$name"."$option")
79 printf '%s' "${value:-$default}"
82 isnumber()
84 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
87 # Given a full hex object ID, is this the zero OID?
88 is_zero_oid () {
89 echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
92 # Sanitize the local git environment for use within a submodule. We
93 # can't simply use clear_local_git_env since we want to preserve some
94 # of the settings from GIT_CONFIG_PARAMETERS.
95 sanitize_submodule_env()
97 save_config=$GIT_CONFIG_PARAMETERS
98 clear_local_git_env
99 GIT_CONFIG_PARAMETERS=$save_config
100 export GIT_CONFIG_PARAMETERS
104 # Add a new submodule to the working tree, .gitmodules and the index
106 # $@ = repo path
108 # optional branch is stored in global branch variable
110 cmd_add()
112 # parse $args after "submodule ... add".
113 reference_path=
114 while test $# -ne 0
116 case "$1" in
117 -b | --branch)
118 case "$2" in '') usage ;; esac
119 branch=$2
120 shift
122 -f | --force)
123 force=$1
125 -q|--quiet)
126 GIT_QUIET=1
128 --progress)
129 progress=1
131 --reference)
132 case "$2" in '') usage ;; esac
133 reference_path=$2
134 shift
136 --reference=*)
137 reference_path="${1#--reference=}"
139 --dissociate)
140 dissociate=1
142 --name)
143 case "$2" in '') usage ;; esac
144 custom_name=$2
145 shift
147 --depth)
148 case "$2" in '') usage ;; esac
149 depth="--depth=$2"
150 shift
152 --depth=*)
153 depth=$1
156 shift
157 break
160 usage
163 break
165 esac
166 shift
167 done
169 if ! git submodule--helper config --check-writeable >/dev/null 2>&1
170 then
171 die "$(eval_gettext "please make sure that the .gitmodules file is in the working tree")"
174 if test -n "$reference_path"
175 then
176 is_absolute_path "$reference_path" ||
177 reference_path="$wt_prefix$reference_path"
179 reference="--reference=$reference_path"
182 repo=$1
183 sm_path=$2
185 if test -z "$sm_path"; then
186 sm_path=$(printf '%s\n' "$repo" |
187 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
190 if test -z "$repo" || test -z "$sm_path"; then
191 usage
194 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
196 # assure repo is absolute or relative to parent
197 case "$repo" in
198 ./*|../*)
199 test -z "$wt_prefix" ||
200 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
202 # dereference source url relative to parent's url
203 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
205 *:*|/*)
206 # absolute url
207 realrepo=$repo
210 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
212 esac
214 # normalize path:
215 # multiple //; leading ./; /./; /../; trailing /
216 sm_path=$(printf '%s/\n' "$sm_path" |
217 sed -e '
218 s|//*|/|g
219 s|^\(\./\)*||
220 s|/\(\./\)*|/|g
221 :start
222 s|\([^/]*\)/\.\./||
223 tstart
224 s|/*$||
226 if test -z "$force"
227 then
228 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
229 die "$(eval_gettext "'\$sm_path' already exists in the index")"
230 else
231 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
232 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
235 if test -z "$force" &&
236 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
237 then
238 eval_gettextln "The following path is ignored by one of your .gitignore files:
239 \$sm_path
240 Use -f if you really want to add it." >&2
241 exit 1
244 if test -n "$custom_name"
245 then
246 sm_name="$custom_name"
247 else
248 sm_name="$sm_path"
251 if ! git submodule--helper check-name "$sm_name"
252 then
253 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
256 # perhaps the path exists and is already a git repo, else clone it
257 if test -e "$sm_path"
258 then
259 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
260 then
261 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
262 else
263 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
266 else
267 if test -d ".git/modules/$sm_name"
268 then
269 if test -z "$force"
270 then
271 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
272 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
273 die "$(eval_gettextln "\
274 If you want to reuse this local git directory instead of cloning again from
275 \$realrepo
276 use the '--force' option. If the local git directory is not the correct repo
277 or you are unsure what this means choose another name with the '--name' option.")"
278 else
279 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
282 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
284 sanitize_submodule_env
285 cd "$sm_path" &&
286 # ash fails to wordsplit ${branch:+-b "$branch"...}
287 case "$branch" in
288 '') git checkout -f -q ;;
289 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
290 esac
291 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
293 git config submodule."$sm_name".url "$realrepo"
295 git add --no-warn-embedded-repo $force "$sm_path" ||
296 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
298 git submodule--helper config submodule."$sm_name".path "$sm_path" &&
299 git submodule--helper config submodule."$sm_name".url "$repo" &&
300 if test -n "$branch"
301 then
302 git submodule--helper config submodule."$sm_name".branch "$branch"
303 fi &&
304 git add --force .gitmodules ||
305 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
307 # NEEDSWORK: In a multi-working-tree world, this needs to be
308 # set in the per-worktree config.
309 if git config --get submodule.active >/dev/null
310 then
311 # If the submodule being adding isn't already covered by the
312 # current configured pathspec, set the submodule's active flag
313 if ! git submodule--helper is-active "$sm_path"
314 then
315 git config submodule."$sm_name".active "true"
317 else
318 git config submodule."$sm_name".active "true"
323 # Execute an arbitrary command sequence in each checked out
324 # submodule
326 # $@ = command to execute
328 cmd_foreach()
330 # parse $args after "submodule ... foreach".
331 while test $# -ne 0
333 case "$1" in
334 -q|--quiet)
335 GIT_QUIET=1
337 --recursive)
338 recursive=1
341 usage
344 break
346 esac
347 shift
348 done
350 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
354 # Register submodules in .git/config
356 # $@ = requested paths (default to all)
358 cmd_init()
360 # parse $args after "submodule ... init".
361 while test $# -ne 0
363 case "$1" in
364 -q|--quiet)
365 GIT_QUIET=1
368 shift
369 break
372 usage
375 break
377 esac
378 shift
379 done
381 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
385 # Unregister submodules from .git/config and remove their work tree
387 cmd_deinit()
389 # parse $args after "submodule ... deinit".
390 deinit_all=
391 while test $# -ne 0
393 case "$1" in
394 -f|--force)
395 force=$1
397 -q|--quiet)
398 GIT_QUIET=1
400 --all)
401 deinit_all=t
404 shift
405 break
408 usage
411 break
413 esac
414 shift
415 done
417 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} "$@"
420 is_tip_reachable () (
421 sanitize_submodule_env &&
422 cd "$1" &&
423 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
424 test -z "$rev"
427 fetch_in_submodule () (
428 sanitize_submodule_env &&
429 cd "$1" &&
430 case "$2" in
432 git fetch ;;
434 shift
435 git fetch $(get_default_remote) "$@" ;;
436 esac
440 # Update each submodule path to correct revision, using clone and checkout as needed
442 # $@ = requested paths (default to all)
444 cmd_update()
446 # parse $args after "submodule ... update".
447 while test $# -ne 0
449 case "$1" in
450 -q|--quiet)
451 GIT_QUIET=1
454 GIT_QUIET=0
456 --progress)
457 progress=1
459 -i|--init)
460 init=1
462 --remote)
463 remote=1
465 -N|--no-fetch)
466 nofetch=1
468 -f|--force)
469 force=$1
471 -r|--rebase)
472 update="rebase"
474 --reference)
475 case "$2" in '') usage ;; esac
476 reference="--reference=$2"
477 shift
479 --reference=*)
480 reference="$1"
482 --dissociate)
483 dissociate=1
485 -m|--merge)
486 update="merge"
488 --recursive)
489 recursive=1
491 --checkout)
492 update="checkout"
494 --recommend-shallow)
495 recommend_shallow="--recommend-shallow"
497 --no-recommend-shallow)
498 recommend_shallow="--no-recommend-shallow"
500 --depth)
501 case "$2" in '') usage ;; esac
502 depth="--depth=$2"
503 shift
505 --depth=*)
506 depth=$1
508 -j|--jobs)
509 case "$2" in '') usage ;; esac
510 jobs="--jobs=$2"
511 shift
513 --jobs=*)
514 jobs=$1
517 shift
518 break
521 usage
524 break
526 esac
527 shift
528 done
530 if test -n "$init"
531 then
532 cmd_init "--" "$@" || return
536 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
537 ${progress:+"--progress"} \
538 ${wt_prefix:+--prefix "$wt_prefix"} \
539 ${prefix:+--recursive-prefix "$prefix"} \
540 ${update:+--update "$update"} \
541 ${reference:+"$reference"} \
542 ${dissociate:+"--dissociate"} \
543 ${depth:+--depth "$depth"} \
544 $recommend_shallow \
545 $jobs \
546 "$@" || echo "#unmatched" $?
547 } | {
548 err=
549 while read -r quickabort sha1 just_cloned sm_path
551 die_if_unmatched "$quickabort" "$sha1"
553 git submodule--helper ensure-core-worktree "$sm_path" || exit 1
555 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
557 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
559 if test $just_cloned -eq 1
560 then
561 subsha1=
562 else
563 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
564 git rev-parse --verify HEAD) ||
565 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
568 if test -n "$remote"
569 then
570 branch=$(git submodule--helper remote-branch "$sm_path")
571 if test -z "$nofetch"
572 then
573 # Fetch remote before determining tracking $sha1
574 fetch_in_submodule "$sm_path" $depth ||
575 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
577 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
578 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
579 git rev-parse --verify "${remote_name}/${branch}") ||
580 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
583 if test "$subsha1" != "$sha1" || test -n "$force"
584 then
585 subforce=$force
586 # If we don't already have a -f flag and the submodule has never been checked out
587 if test -z "$subsha1" && test -z "$force"
588 then
589 subforce="-f"
592 if test -z "$nofetch"
593 then
594 # Run fetch only if $sha1 isn't present or it
595 # is not reachable from a ref.
596 is_tip_reachable "$sm_path" "$sha1" ||
597 fetch_in_submodule "$sm_path" $depth ||
598 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'; trying to directly fetch \$sha1:")"
600 # Now we tried the usual fetch, but $sha1 may
601 # not be reachable from any of the refs
602 is_tip_reachable "$sm_path" "$sha1" ||
603 fetch_in_submodule "$sm_path" $depth "$sha1" ||
604 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
607 must_die_on_failure=
608 case "$update_module" in
609 checkout)
610 command="git checkout $subforce -q"
611 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
612 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
614 rebase)
615 command="git rebase"
616 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
617 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
618 must_die_on_failure=yes
620 merge)
621 command="git merge"
622 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
623 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
624 must_die_on_failure=yes
627 command="${update_module#!}"
628 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
629 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
630 must_die_on_failure=yes
633 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
634 esac
636 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
637 then
638 say "$say_msg"
639 elif test -n "$must_die_on_failure"
640 then
641 die_with_status 2 "$die_msg"
642 else
643 err="${err};$die_msg"
644 continue
648 if test -n "$recursive"
649 then
651 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
652 wt_prefix=
653 sanitize_submodule_env
654 cd "$sm_path" &&
655 eval cmd_update
657 res=$?
658 if test $res -gt 0
659 then
660 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
661 if test $res -ne 2
662 then
663 err="${err};$die_msg"
664 continue
665 else
666 die_with_status $res "$die_msg"
670 done
672 if test -n "$err"
673 then
674 OIFS=$IFS
675 IFS=';'
676 for e in $err
678 if test -n "$e"
679 then
680 echo >&2 "$e"
682 done
683 IFS=$OIFS
684 exit 1
690 # Configures a submodule's default branch
692 # $@ = requested path
694 cmd_set_branch() {
695 unset_branch=false
696 branch=
698 while test $# -ne 0
700 case "$1" in
701 -q|--quiet)
702 # we don't do anything with this but we need to accept it
704 -d|--default)
705 unset_branch=true
707 -b|--branch)
708 case "$2" in '') usage ;; esac
709 branch=$2
710 shift
713 shift
714 break
717 usage
720 break
722 esac
723 shift
724 done
726 if test $# -ne 1
727 then
728 usage
731 # we can't use `git submodule--helper name` here because internally, it
732 # hashes the path so a trailing slash could lead to an unintentional no match
733 name="$(git submodule--helper list "$1" | cut -f2)"
734 if test -z "$name"
735 then
736 exit 1
739 test -n "$branch"; has_branch=$?
740 test "$unset_branch" = true; has_unset_branch=$?
742 if test $((!$has_branch != !$has_unset_branch)) -eq 0
743 then
744 usage
747 if test $has_branch -eq 0
748 then
749 git submodule--helper config submodule."$name".branch "$branch"
750 else
751 git submodule--helper config --unset submodule."$name".branch
756 # Show commit summary for submodules in index or working tree
758 # If '--cached' is given, show summary between index and given commit,
759 # or between working tree and given commit
761 # $@ = [commit (default 'HEAD'),] requested paths (default all)
763 cmd_summary() {
764 summary_limit=-1
765 for_status=
766 diff_cmd=diff-index
768 # parse $args after "submodule ... summary".
769 while test $# -ne 0
771 case "$1" in
772 --cached)
773 cached="$1"
775 --files)
776 files="$1"
778 --for-status)
779 for_status="$1"
781 -n|--summary-limit)
782 summary_limit="$2"
783 isnumber "$summary_limit" || usage
784 shift
786 --summary-limit=*)
787 summary_limit="${1#--summary-limit=}"
788 isnumber "$summary_limit" || usage
791 shift
792 break
795 usage
798 break
800 esac
801 shift
802 done
804 test $summary_limit = 0 && return
806 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
807 then
808 head=$rev
809 test $# = 0 || shift
810 elif test -z "$1" || test "$1" = "HEAD"
811 then
812 # before the first commit: compare with an empty tree
813 head=$(git hash-object -w -t tree --stdin </dev/null)
814 test -z "$1" || shift
815 else
816 head="HEAD"
819 if [ -n "$files" ]
820 then
821 test -n "$cached" &&
822 die "$(gettext "The --cached option cannot be used with the --files option")"
823 diff_cmd=diff-files
824 head=
827 cd_to_toplevel
828 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
829 # Get modified modules cared by user
830 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
831 sane_egrep '^:([0-7]* )?160000' |
832 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
834 # Always show modules deleted or type-changed (blob<->module)
835 if test "$status" = D || test "$status" = T
836 then
837 printf '%s\n' "$sm_path"
838 continue
840 # Respect the ignore setting for --for-status.
841 if test -n "$for_status"
842 then
843 name=$(git submodule--helper name "$sm_path")
844 ignore_config=$(get_submodule_config "$name" ignore none)
845 test $status != A && test $ignore_config = all && continue
847 # Also show added or modified modules which are checked out
848 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
849 printf '%s\n' "$sm_path"
850 done
853 test -z "$modules" && return
855 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
856 sane_egrep '^:([0-7]* )?160000' |
857 cut -c2- |
858 while read -r mod_src mod_dst sha1_src sha1_dst status name
860 if test -z "$cached" &&
861 is_zero_oid $sha1_dst
862 then
863 case "$mod_dst" in
864 160000)
865 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
867 100644 | 100755 | 120000)
868 sha1_dst=$(git hash-object $name)
870 000000)
871 ;; # removed
873 # unexpected type
874 eval_gettextln "unexpected mode \$mod_dst" >&2
875 continue ;;
876 esac
878 missing_src=
879 missing_dst=
881 test $mod_src = 160000 &&
882 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
883 missing_src=t
885 test $mod_dst = 160000 &&
886 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
887 missing_dst=t
889 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
891 total_commits=
892 case "$missing_src,$missing_dst" in
894 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
897 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
899 t,t)
900 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
903 errmsg=
904 total_commits=$(
905 if test $mod_src = 160000 && test $mod_dst = 160000
906 then
907 range="$sha1_src...$sha1_dst"
908 elif test $mod_src = 160000
909 then
910 range=$sha1_src
911 else
912 range=$sha1_dst
914 GIT_DIR="$name/.git" \
915 git rev-list --first-parent $range -- | wc -l
917 total_commits=" ($(($total_commits + 0)))"
919 esac
921 sha1_abbr_src=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_src 2>/dev/null ||
922 echo $sha1_src | cut -c1-7)
923 sha1_abbr_dst=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_dst 2>/dev/null ||
924 echo $sha1_dst | cut -c1-7)
926 if test $status = T
927 then
928 blob="$(gettext "blob")"
929 submodule="$(gettext "submodule")"
930 if test $mod_dst = 160000
931 then
932 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
933 else
934 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
936 else
937 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
939 if test -n "$errmsg"
940 then
941 # Don't give error msg for modification whose dst is not submodule
942 # i.e. deleted or changed to blob
943 test $mod_dst = 160000 && echo "$errmsg"
944 else
945 if test $mod_src = 160000 && test $mod_dst = 160000
946 then
947 limit=
948 test $summary_limit -gt 0 && limit="-$summary_limit"
949 GIT_DIR="$name/.git" \
950 git log $limit --pretty='format: %m %s' \
951 --first-parent $sha1_src...$sha1_dst
952 elif test $mod_dst = 160000
953 then
954 GIT_DIR="$name/.git" \
955 git log --pretty='format: > %s' -1 $sha1_dst
956 else
957 GIT_DIR="$name/.git" \
958 git log --pretty='format: < %s' -1 $sha1_src
960 echo
962 echo
963 done
966 # List all submodules, prefixed with:
967 # - submodule not initialized
968 # + different revision checked out
970 # If --cached was specified the revision in the index will be printed
971 # instead of the currently checked out revision.
973 # $@ = requested paths (default to all)
975 cmd_status()
977 # parse $args after "submodule ... status".
978 while test $# -ne 0
980 case "$1" in
981 -q|--quiet)
982 GIT_QUIET=1
984 --cached)
985 cached=1
987 --recursive)
988 recursive=1
991 shift
992 break
995 usage
998 break
1000 esac
1001 shift
1002 done
1004 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
1007 # Sync remote urls for submodules
1008 # This makes the value for remote.$remote.url match the value
1009 # specified in .gitmodules.
1011 cmd_sync()
1013 while test $# -ne 0
1015 case "$1" in
1016 -q|--quiet)
1017 GIT_QUIET=1
1018 shift
1020 --recursive)
1021 recursive=1
1022 shift
1025 shift
1026 break
1029 usage
1032 break
1034 esac
1035 done
1037 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
1040 cmd_absorbgitdirs()
1042 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1045 # This loop parses the command line arguments to find the
1046 # subcommand name to dispatch. Parsing of the subcommand specific
1047 # options are primarily done by the subcommand implementations.
1048 # Subcommand specific options such as --branch and --cached are
1049 # parsed here as well, for backward compatibility.
1051 while test $# != 0 && test -z "$command"
1053 case "$1" in
1054 add | foreach | init | deinit | update | set-branch | status | summary | sync | absorbgitdirs)
1055 command=$1
1057 -q|--quiet)
1058 GIT_QUIET=1
1060 -b|--branch)
1061 case "$2" in
1063 usage
1065 esac
1066 branch="$2"; shift
1068 --cached)
1069 cached="$1"
1072 break
1075 usage
1078 break
1080 esac
1081 shift
1082 done
1084 # No command word defaults to "status"
1085 if test -z "$command"
1086 then
1087 if test $# = 0
1088 then
1089 command=status
1090 else
1091 usage
1095 # "-b branch" is accepted only by "add" and "set-branch"
1096 if test -n "$branch" && (test "$command" != add || test "$command" != set-branch)
1097 then
1098 usage
1101 # "--cached" is accepted only by "status" and "summary"
1102 if test -n "$cached" && test "$command" != status && test "$command" != summary
1103 then
1104 usage
1107 "cmd_$(echo $command | sed -e s/-/_/g)" "$@"